<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 11/10/2004 *
 * ===============                              Last change: 03/18/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : bonus_functions.php                              *
 * -------------------------------------------------------------------- *
 * Short description : Special functions for bonus extension            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Spezielle Funktion fuer bonus-Erweiterung        *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// This function must be run *BEFORE* a link is removed from table 'mxchange_user_links' !
function BONUS_ADD_TURBO_POINTS($mid, $uid, $type) {
	global $_CONFIG;

	// Shall we add bonus points?
	if (getConfig('bonus_active') == "N") return false;

	// Init variables
	$SQL = ""; $bonys = 0; $mail = 0; $column = "";

	// Select SQL command
	switch ($type)
	{
	case "bonusid":
		$column = "bonus_id";
		$bonus = $mid;
		break;

	case "mailid" :
		$column = "mail_id";
		$mail = $mid;
		break;

	default:
		DEBUG_LOG(__FUNCTION__, __LINE__, sprintf("Invalid type %s detected.", $type));
		break;
	}

	// Is a column name set?
	if (empty($column)) {
		// No, then abort here
		return false;
	} // END - if

	// Check for entry
	$result = SQL_QUERY_ESC("SELECT COUNT(id) AS cnt FROM  "._MYSQL_PREFIX."_bonus_turbo WHERE userid=%s AND %s=%s LIMIT 1",
		array($uid, $column, $mid), __FILE__, __LINE__);

	// Load clicks from table as current rank
	list($rank) = SQL_FETCHROW($result);

	// Add one line
	$rank++;

	// Free result
	SQL_FREERESULT($result);

	// Which rank?
	if ($rank == 1) {
		// First rank!
		$points = getConfig('turbo_bonus');
	} else {
		// Anything else so let's explode all entered rank points
		$test = explode(";", getConfig('turbo_rates'));
		if (!empty($test[$rank - 2])) {
			// Level found
			$points = $test[$rank - 2];
		} else {
			// Level not found!
			$points = "0.00000";
		}
	}

	// Add points to his account directly
	$result = SQL_QUERY_ESC("UPDATE `"._MYSQL_PREFIX."_user_data` SET turbo_bonus=turbo_bonus+".$points." WHERE userid=%s LIMIT 1",
		array(bigintval($uid)), __FILE__, __LINE__);

	// Rember this whole data for displaying ranking list
	$result = SQL_QUERY_ESC("INSERT INTO "._MYSQL_PREFIX."_bonus_turbo (userid, mail_id, bonus_id, level, points, timemark) VALUES ('%s', '%s', '%s', '%s', '%s', UNIX_TIMESTAMP())",
		array(bigintval($uid), bigintval($mail), bigintval($bonus), $rank, $points), __FILE__, __LINE__);

	if ((GET_EXT_VERSION("bonus") >= "0.3.5") && (getConfig('bonus_mode') != "ADD") && ($points > 0)) BONUS_POINTS_HANDLER($points);
}
//
function BONUS_MAKE_RANK_ROWS ($data, $type, $uid) {
	global $_CONFIG;
	$self = false; $OUT = "";

	// How many ranks do we have?
	$ranks = sizeof(explode(";", getConfig('turbo_rates'))) + 1;

	// Load current user's data
	$result = SQL_QUERY_ESC("SELECT level, points, timemark FROM "._MYSQL_PREFIX."_bonus_turbo WHERE %s=%s AND userid=%s LIMIT 1",
		array($type, $data, $uid), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) == 1) {
		// Load data
		list($rank, $points, $mark) = SQL_FETCHROW($result);

		// Remember all values for later use
		$self  = true; $points = TRANSLATE_COMMA($points);

		// Transfer data to template
		define('__YR_LEVEL' , $rank);
		define('__YR_POINTS', $points);
		define('__YR_TMARK' , MAKE_DATETIME($mark, "1"));

		// Load template
		define('__YOUR_RANKING_LINE', LOAD_TEMPLATE("show_bonus_yr", true));
	} // END - if

	// Load rankings
	$result = SQL_QUERY_ESC("SELECT id FROM "._MYSQL_PREFIX."_bonus_turbo WHERE %s=%s ORDER BY level LIMIT %s",
		array($type, $data, getConfig('bonus_lines')), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) > 0) {
		// Start generating the ranking list
		$max = SQL_NUMROWS($result);

		$SW = 2;
		for ($rank = 1; $rank <= $max; $rank++) {
			// Load data
			$result_users = SQL_QUERY_ESC("SELECT userid, points, timemark FROM "._MYSQL_PREFIX."_bonus_turbo WHERE %s=%s AND level=%s LIMIT 1",
				array($type, $data, $rank), __FILE__, __LINE__);

			// Nothing found by default
			$userid = "---"; $points = "---";

			// Are you one of them?
			if (SQL_NUMROWS($result_users) == 1) {
				// Load data
				list($userid, $points, $mark) = SQL_FETCHROW($result_users);

				// Translate comma
				$points = TRANSLATE_COMMA($points);
			} // END - if

			// Output row
			$OUT .= "<TR>
  <TD class=\"bonus_rank_".$rank." bottom2 switch_sw".$SW."\">&nbsp;".$rank.".</TD>
  <TD class=\"bonus_rank_".$rank." bottom2 switch_sw".$SW."\" align=\"center\">".$userid."</TD>
  <TD class=\"bonus_rank_".$rank." bottom2 switch_sw".$SW."\" align=\"center\">".$points."</TD>
</TR>\n";
			$SW = 3 - $SW;
		} // END - for

		if (!$self) {
			// If current user was not found set constant
			define('__YOUR_RANKING_LINE', BONUS_RANK_YOU_ARE_NOT_FOUND);
		} // END - if
	} else {
		// No entries found!
		$OUT = "<TR>
  <TD colspan=\"3\" align=\"center\" height=\"30\" class=\"bottom2\">
    <STRONG class=\"guest_failed\">".BONUS_NO_RANKS_1.$data.BONUS_NO_RANKS_2."</STRONG>
  </TD>
</TR>\n";
		define('__YOUR_RANKING_LINE', "");
	}
	return $OUT;
}
//
function BONUS_POINTS_HANDLER ($MODE) {
	global $_CONFIG;

	// Shall we add bonus points?
	if (getConfig('bonus_active') == "N") return;

	// Switch to jackpot-mode when no UID is supplied but userid-mode is selected
	if ((getConfig('bonus_mode') == "UID") && (getConfig('bonus_uid') == "0")) {
		// Update database
		UPDATE_CONFIG(array('bonus_mode'), array("JACKPOT"));

		// Update configuration
		$_CONFIG['bonus_mode'] = "JACKPOT";
	} // END - if

	if ($MODE == "login_bonus") {
		// Login bonus detected
		$points = getConfig('login_bonus');
	} else {
		// Direct points supplied
		$points = $MODE;
	}

	// Subtract points from...
	switch (getConfig('bonus_mode'))
	{
	case "JACKPOT": // ... jackpot
		if ((SUB_JACKPOT($points) == -1) && (getConfig('bonus_uid') > 0)) {
			// Check points amount first...
			$TOTAL = GET_TOTAL_DATA(getConfig('bonus_uid'), "user_points", "points") - GET_TOTAL_DATA(getConfig('bonus_uid'), "user_data", "used_points");
			if ($TOTAL >= $points) {
				// Subtract points from userid's account
				SUB_POINTS("bonus_payout_jackpot", getConfig('bonus_uid'), $points);
			} // END - if
		} // END - if
		break;

	case "UID": // ... userid's account
		// Check his amount first
		$TOTAL = GET_TOTAL_DATA(getConfig('bonus_uid'), "user_points", "points") - GET_TOTAL_DATA(getConfig('bonus_uid'), "user_data", "used_points");
		if ($TOTAL >= $points) {
			// Subtract points from userid's account
			SUB_POINTS("bonus_payout_uid", getConfig('bonus_uid'), $points);
		} else {
			// Try to subtract from jackpot
			$dummy = SUB_JACKPOT($points);
		}
		break;
	}
}
//
function BONUS_PURGE_EXPIRED_TURBO_BONUS()
{
	global $_CONFIG;

	// Remove entries
	$result = SQL_QUERY("DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_bonus_turbo WHERE timemark < (UNIX_TIMESTAMP() - ".getConfig('bonus_timeout').")", __FILE__, __LINE__);
	if (SQL_AFFECTEDROWS() > 0) {
		// Send out email to admin
		SEND_ADMIN_NOTIFICATION(AUTOPURGE_ADMIN_TURBO_SUBJECT, "admin_autopurge_turbo", SQL_AFFECTEDROWS(), "");
	}
}
//
?>
